<?php
set_time_limit(60);

global $ADEI_TIMINGS;
global $EXPORT_SAMPLING_RATES;
global $EXPORT_FORMATS;

ADEI::RequireClass("export");
ADEI::RequireClass("draw");

header("Content-type: text/plain");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");


define("INFO_MODE", 1);
define("SOURCE_MODE", 2);
define("PASSTHROUGH_MODE", 3);

$mode = 0;

    // For INFO_MODE
$value_arg = false;
$name_arg = "name";

if (isset($_GET['menu'])) $menu = true;
else $menu = false; 

$flags = 0;
if ($_GET['list_virtual']) $flags |= REQUEST::LIST_VIRTUAL;
if ($_GET['list_complex']) $flags |= REQUEST::LIST_COMPLEX;
if ($_GET['list_custom']) $flags |= REQUEST::LIST_CUSTOM;
if ($_GET['skip_uncached']) $flags |= REQUEST::SKIP_UNCACHED;
if ($_GET['info']) $flags |= REQUEST::NEED_INFO|REQUEST::NEED_AXISINFO;
if ($_GET['archives']) $flags |= REQUEST::LIST_ALL|REQUEST::LIST_WILDCARDED;


$req = new REQUEST();

try {
    switch($_GET['target']) {
      case 'all_items':
	$slist = $req->GetSources($flags);
	foreach ($slist as $sid => $sreq) {
	    $glist = $sreq->GetGroups(NULL, $flags&~REQUEST::LIST_ALL);
	    foreach ($glist as $gid => $greq) {
		$list = $greq->GetItemList($flags);
		foreach ($list as $iid => &$item) {
		    $id = $sid . "__" . $gid . "__" . $iid;
		    $uid = trim($item['uid']?$item['uid']:'-');
		    printf("%s    %s    %s\n", str_pad($id, 50), str_pad($uid, 24), trim($item['name']));
		}
		flush();
		ob_flush();
		set_time_limit(60);
	    }
	}

	break;
    default:
	if (isset($_GET['target'])) $error = translate("Unknown list target (%s) is specified", $_GET['target']);
	else $error = translate("The list target is not specified");
    }
} catch (ADEIException $ex) {
    $ex->logInfo(NULL, $reader?$reader:$req);
    $error = xml_escape($ex->getInfo());
}

if ($error) {
    echo "Error: $error\n";
}

?>